package com.example.shoppinglisting.ApiConnection

import com.example.shoppinglisting.Models.ProductInShopList
import com.example.shoppinglisting.Models.Products
import com.example.shoppinglisting.Models.ShoppingLists
import com.google.gson.Gson
import com.google.gson.GsonBuilder
import retrofit2.Call
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import retrofit2.http.Body
import retrofit2.http.DELETE
import retrofit2.http.GET
import retrofit2.http.POST
import retrofit2.http.Query

interface APIInterface {
    @GET("api/VerifacationUser")
    fun VerificateUser(@Query("name")  name : String, @Query("password") password : String) : Call<Void>

    @POST("api/AddNewUser")
    fun AddNewUser(@Query("username") username : String, @Query("password") password: String) : Call<Void>

    @GET("api/GetAllLists")
    fun GetAllLists(@Query("id_user")  idUser : Int) : Call<MutableList<ShoppingLists>>

    @GET("api/GetAllProductInShopList")
    fun GetAllProductInShopList(@Query("nameShopList")  nameShopList : String) : Call<MutableList<ProductInShopList>>

    @GET("api/GetAllProduct")
    fun GetAllProduct() : Call<MutableList<Products>>

    @POST("api/AddNewProductIsShopList")
    fun AddNewProductIsShopList(@Body productInShopList: ProductInShopList) : Call<ProductInShopList>

    @DELETE("api/DeleteShopList")
    fun DeleteShopList(@Query("id") idShopList : Int) : Call<Void>

    @DELETE("api/DeleteProductInShopList")
    fun DeleteProductInShopList(@Query("idProduct") idProduct : Int) : Call<Void>
}

public object RetrofitConnection{
    var Base_URL = "https://iis.ngknn.ru/ngknn/МамшеваЮС/6/"

    var gson : Gson = GsonBuilder().setLenient().create()

    private var connection : Retrofit? = null

    fun getRetrofit() : Retrofit
    {
        if(connection == null)
        {
            connection = Retrofit.Builder().
            baseUrl(Base_URL).addConverterFactory(GsonConverterFactory
                .create(gson)).build()
            return connection!!
        }
        return  connection!!
    }
}

public object RetrofitInterface
{
    fun getRetrofit(retrofitConnection: Retrofit) : APIInterface
    {
        return  retrofitConnection.create(APIInterface::class.java)
    }
}