package com.example.shoppinglisting

import android.content.Intent
import android.os.Bundle
import android.widget.Toast
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import com.example.shoppinglisting.ApiConnection.RetrofitConnection
import com.example.shoppinglisting.ApiConnection.RetrofitInterface
import com.example.shoppinglisting.databinding.ActivityLoginBinding
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.create

class activity_login : AppCompatActivity() {
    private lateinit var binding: ActivityLoginBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityLoginBinding.inflate(layoutInflater)
        setContentView(binding.root)

        val retrofit = RetrofitConnection.getRetrofit()
        val apiInterface = RetrofitInterface.getRetrofit(retrofit)

        // Обработка нажатия на кнопку входа
        binding.loginButton.setOnClickListener {
            val username = binding.usernameEditText.text.toString()
            val password = binding.passwordEditText.text.toString()

            // Проверка на пустоту полей
            if (username.isNotEmpty() && password.isNotEmpty()) {
                // Вызов метода для проверки пользователя
                apiInterface.VerificateUser(username, password).enqueue(object : Callback<Void> {
                    override fun onResponse(call: Call<Void>, response: Response<Void>) {
                        if (response.isSuccessful) {
                            if (response.code() == 200) {
                                // Вход выполнен успешно, переходим на основной экран
                                startActivity(Intent(this@activity_login, MainActivity::class.java))
                                var username : String = binding.usernameEditText.text.toString()
                                var password : String = binding.passwordEditText.text.toString()
                                intent.putExtra("username", username)
                                intent.putExtra("password", password)
                                finish()
                            } else {
                                // Неправильное имя пользователя или пароль
                                Toast.makeText(this@activity_login, "Неправильное имя пользователя или пароль", Toast.LENGTH_SHORT).show()
                            }
                        }
                    }

                    override fun onFailure(call: Call<Void>, t: Throwable) {
                        Toast.makeText(this@activity_login, "Ошибка соединения с сервером", Toast.LENGTH_SHORT).show()
                    }
                })
            } else {
                // Поля не должны быть пустыми
                Toast.makeText(this@activity_login, "Имя пользователя и пароль не должны быть пустыми", Toast.LENGTH_SHORT).show()
            }
        }

        // Обработка нажатия на ссылку для регистрации
        binding.registerTextView.setOnClickListener {
            startActivity(Intent(this, activity_registration::class.java))
        }
    }
}